/****************************************************************************
 *       FileName   :        DSFileSystem.h                                 *
 *       Programmer :        AAAwen                                         *
 *       Writen at  :        2005.05.10                                     *
 *       Version    :        1.0                                            *
 *       Description:        define filesystem of flash			     		*
 *       Last modify:        2005.05.10                                      *
 ****************************************************************************/

#ifndef		__DSFILESYSTEM_H_ICL__
#define		__DSFILESYSTEM_H_ICL__
#include 	"basetype.h"
#include 	<stdio.h>

//typedef char* HDSFILE;
/*!
	Ѿȡֽ
*/
#define		SEEK_CLR_RCNT	SEEK_END+10
#define		SEEK_CUR_EX		SEEK_END+11

// ޸DSеļϵͳ
#define	DS_FILESYSTEM_ADDR			0x3b0000
#define	DS_FILESYSTEM_LEN			(0x50000-4)

#define	DS_SECTION_OUT			-1	// ƳԽ
#define	DS_SECTION_NOEXIST		0	// Ʋ
#define	DS_SECTION_EXIST		1	// ƴ
#define	DS_SECTION_SEARCH		2	// Ʋ

typedef struct tsgDSFILE
{
	/*!
		ļݳ
	*/
	long		m_lContentLen;
	/*!
		ļȡĵǰλ
	*/
	long		m_lOffset;
	/*!
		ļȡֽ
	*/
	long		m_lReadCount;

	// Żļȡ
	/*!
		Ƿ
	*/
	long		m_lSectionOk;
	/*!
		
	*/
	long		m_lSectionLines;
	/*!
		ӱʶ
	*/
	long		m_lSectionLinesAddFlag;
	/*!
		ļеƫλ
	*/
	long		m_lSectionOffset;
	/*!
		
	*/
	char		m_szSection[64];
	/*!
		ļ
	*/
	char		*m_pContent;
}DSFILE, *HDSFILE;

#ifdef OS_WINDOWS
#pragma pack (push,1)
typedef struct tagDSFILESYSTEMHEAD
{
	/*!
		ļϵͳļ
	*/
	int			m_iFiles;
	/*!
		ļϵͳļƫ
		\note
			һļ=this+m_iOffset
	*/
	int			m_iOffset;
}DSFILESYSTEMHEAD;

typedef struct tagDSFILEHEAD
{
	/*!
		ļ(ļ+ļͷ)
	*/
	int			m_iFileSize;
	/*!
		ļƫ
	*/
	int			m_iOffset;
	/*!
		ļ
	*/
	int			m_iFileNameLen;
	/*!
		ļ
	*/
	char		m_FileName[1];
}DSFILEHEAD, *pDSFILEHEAD;

typedef	struct tagFILECONTENT
{
	long		m_lContentLen;
	long		m_lOffset;
	char		m_pContent[1];
}FILECONTENT, *pFILECONTENT;
#pragma pack (pop)
#else
typedef struct tagDSFILESYSTEMHEAD
{
	/*!
		ļϵͳļ
	*/
	int			m_iFiles	;
	/*!
		ļϵͳļƫ
		\note
			һļ=this+m_iOffset
	*/
	int			m_iOffset	;
}DSFILESYSTEMHEAD;

typedef struct tagDSFILEHEAD
{
	/*!
		ļ(ļ+ļͷ)
	*/
	int			m_iFileSize	;
	/*!
		ļƫ
	*/
	int			m_iOffset	;
	/*!
		ļ
	*/
	int			m_iFileNameLen	;
	/*!
		ļ
	*/
	char		m_FileName[1]	;
}DSFILEHEAD, *pDSFILEHEAD;

typedef	struct tagFILECONTENT
{
	long		m_lContentLen	;
	long		m_lOffset		;
	char		m_pContent[1]	;
}FILECONTENT, *pFILECONTENT;
#endif



/*!
	\brief ָļĿڴ
	\param szFileName -- Ҫļ
	\param ppDestMem  -- Ŀڴָָ
	\retval           -- طڴ泤
	\note
	    ڴʧܻļΪշ0\n
		pDestMemʹúеͷ
 */
long LoadFile(const char *szFileName, char **ppDestMem);

/*!
	\brief ָļĿڴ
	\param szFileName -- Ҫļ
	\param ppDestMem  -- Ŀڴָָ
	\param pFSAddr    -- ļϵͳ׵ַָ
	\retval           -- طڴ泤
	\note
	    ڴʧܻļΪշ0\n
		pDestMemʹúеͷ
 */
long LoadFileInDSFS(const char *szFileName, char **ppDestMem, BYTE *pFSAddr);

/*!
	\brief ƫ
	\param stream     -- ָ
	\param offset     -- originƫֵ
	\param origin     -- ʼλ
	\retval           -- ɹ0
 */
DSLIB_API int DS_Seek(FILECONTENT *stream, long offset, int origin);
DSLIB_API char *DS_Gets(char *pDest, int iDestMax, FILECONTENT *stream);

/*!
	\brief ȡļ
	\param fp -- Ѿ򿪵ļָ
	\retval   -- ļ
 */
DSLIB_API int GetFileLen(FILE *fp);

/*!
	\brief ָļĿڴ
	\param szFileName -- Ҫļ
	\retval           -- ļ
	\note
	    ڴʧܻļΪշ0\n
		pDestMemʹúеͷ
 */
DSLIB_API HDSFILE DSOpenFile(const char *szFileName);
DSLIB_API HDSFILE DSOpenFileEx(const char *szFileName);
/*!
	\brief ָļĿڴ
	\param szRootDir  -- ļϵͳĸ·
	\param szFileName -- Ҫļ
	\retval           -- ļ
	\note
	    ڴʧܻļΪշ0\n
		pDestMemʹúеͷ
		úʺpcϵͳļϵͳϢ
		ǶʽϵͳУ1
		
 */
DSLIB_API HDSFILE DSOpenFileEx3(const char *szRootDir, const char *szFileName);
DSLIB_API HDSFILE DSOpenFileEx2(const char *szRootDir, const char *szFSName, const char *szFileName);

/*!
	\brief رմ򿪵ļ
	\param hFile -- 򿪵ļ
	\note
	    ڴʧܻļΪշ0\n
		pDestMemʹúеͷ
 */
DSLIB_API BOOL DSCloseFile(HDSFILE hFile);

/*!
	\brief лȡ
	\param buffer     -- ȡݻָ
	\param size       -- ȡݵԪĳ
	\param count      -- ȡݵԪ
	\param hFile      -- ָ
	\retval           -- ɹʵʵĶȡݵԪ
 */
DSLIB_API size_t DSfread(void *buffer, size_t size, size_t count, HDSFILE hFile);
/*!
	\brief ȡһַ(Իسͻн)	
	\param string     -- ȡַĻָ
	\param origin     -- 
	\param hFile      -- ָ
	\retval           -- ɹضȡַָ
 */
DSLIB_API char *DSfgets(char *string, int iMaxSize, HDSFILE hFile);
/*!
	\brief ȡһַ(Իسͻн)	
	\param string     -- ȡַĻָ
	\param origin     -- 
	\param hFile      -- ָ
	\param ioffset    -- ǰλöȡƫ
	\retval           -- ɹضȡַָ
	\note
		ȡָ벻ƶ,ҪûԤ
 */
DSLIB_API char *DSfgetsEx(char *string, int iMaxSize, HDSFILE hFile);
/*!
	\brief ȡļѾȡ
	\param hFile      -- ָ
	\retval           -- ʵʶȡ
 */
DSLIB_API int DSfgetreadcount(HDSFILE hFile);
/*!
	\brief ƫ
	\param hFile      -- ָ
	\param offset     -- originƫֵ
	\param origin     -- ʼλ
	\retval           -- ɹ0
 */
DSLIB_API int DSfseek(HDSFILE hFile, long offset, int origin);
/*!
	\brief Ƿײ
	\param hFile      -- ָ
	\retval           -- ɹ0
 */
DSLIB_API int DSfeof(HDSFILE hFile);
/*!
	\brief Ƿײ
	\param hFile      -- ָ
	\retval           -- ɹ0
 */
DSLIB_API int DSfeofEx(HDSFILE hFile);
/*!
	\brief Ƿȫ
	\param hFile      -- ָ
	\retval           -- ɹ0,Ϊֽ
 */
DSLIB_API int DSfeob(HDSFILE hFile);
/*!
	\brief ƫ
	\param hFile      -- ָ
	\retval           -- ƫ
 */
DSLIB_API int DSftell(HDSFILE hFile);
DSLIB_API int DSHaveSection(char *pSection, HDSFILE hFile);
DSLIB_API int DSSaveSectionOffset(HDSFILE hFile);
DSLIB_API int DSRestoreSectionOffset(HDSFILE hFile);
DSLIB_API int DSAddSectionLines(int iLines, HDSFILE hFile);
DSLIB_API int DSSubSectionLines(int iLines, HDSFILE hFile);
DSLIB_API int DSSetSectionLinesAddFlag(int iFlag, HDSFILE hFile);
DSLIB_API int DSSectionisOver(int iReadLines, HDSFILE hFile);

/*!
	\brief ϲļ
	\param szListFileName -- Ҫϲļбļ
	\param szDestFileName -- ϲĿļ
	\param szDestDir       -- ļ·
	\retval               -- ɹTRUE
	\note
		ϲļżֽڶ
 */
DSLIB_API BOOL FsCombinAllFile(const char *szListFileName, const char *szDestFileName, const char *szDestDir);

/*!
	\brief ļ
	\param szCombinFile   -- ϲļ
	\param szDestDir      -- ҪļĿ¼
	\retval               -- ɹTRUE
 */
DSLIB_API BOOL FsSplitAllFile(const char *szCombinFile, const char *szDestDir);

//
/*!
	\brief ȡϲļ(ļϵͳ)
	\param szCombinFile   -- ϲļ
	\retval               -- ɹTRUE
 */
DSLIB_API BYTE *FsReadCombinFile(const char *szCombinFile);
DSLIB_API BYTE *FsReadCombinFileEx(const char *szCombinFile);

/*!
	\brief װļϵͳ
	\param szFileSystem   -- ļϵͳ
	\param ppDestBuf      -- ļϵͳĿĻ
	\retval               -- ɹTRUE
 */
DSLIB_API BOOL FsLoadFileSystem(const char *szFileSystem, BYTE **ppDestBuf);

/*!
	\brief жļϵͳ
	\param ppDestBuf      -- ļϵͳĿĻ
	\retval               -- ɹTRUE
 */
DSLIB_API BOOL FsUnLoadFileSystem(BYTE **ppDestBuf);

/*!
	\brief ʾָļϵͳ·ļ
	\param szPath         -- Ҫʾļϵͳ·
	\param szFileSystem   -- ָļϵͳ
	\retval               -- ɹTRUE
 */
DSLIB_API BOOL FsDirFileName(const char *szPath, const char *szFileSystem); 

DSLIB_API void FsDispHead(const char *szName, const char *szFileSystem);

BOOL FsNetToHost(BYTE *pFSBuf);
BOOL FsHostToNet(BYTE *pFSBuf);

void DispMemoryData(const BYTE *pu8Addr, int iLen, int iNumofLine);
#endif