/****************************************************************************
 *       FileName   :        Common.h                                       *
 *       Programmer :        Li Liangchu                                    *
 *       Writen at  :        2002.09.20                                     *
 *       Version    :                                                       *
 *       Description:        header of the nport.c			     		    *
 *       Last modify:        2002.11.6                                      *
 ****************************************************************************/

#ifndef		__COMMON_H_ICL__
#define		__COMMON_H_ICL__

#ifdef _WIN32
#else
#define OS_UNIX
#endif

#ifdef _WIN32

#ifdef _DEBUG
// #define _OS_WINDOWS_DEBUG_
#else  // _DEBUG
#define _OS_WINDOWS_
#endif // _DEBUG
#include        <windows.h>
#include		<winsock.h>
#include        <dos.h>
#include        <direct.h>
#include 		<sys/timeb.h>
#include		<process.h>
#else
#include 		<sys/time.h>
#include		<netinet/in.h>
#endif

#include        "platform_def.h"
#include        <stdio.h>
#include        <string.h>
#include 		<time.h>

//#include		"menu.h"

// 
#include		"basefunc.h"
#include		"DSFileSystem.h"
#include		"chainlist.h"
#include		"os_heap.h"
#include		"basetype.h"
#include		"confrw.h"

#define	 		OPEN				0
#define			CLOSE				1

// wen 2005.04.12 Ϣʽ
/* !ϢΪʾϢ
*/
#define	MSG_CLASS_TIP		1
/* !ϢΪϢ
*/
#define	MSG_CLASS_WARN		2
/* !ϢΪϢ
*/
#define	MSG_CLASS_ERROR		3

/*! 
 * ˿ڶʶ 
*/
#define FLAG_READ		0x0001

/*! 
 * ˿дʶ 
*/
#define FLAG_WRITE		0x0002

/*! 
 * ˿ڶʶ 
*/
#define FLAG_OPEN		(FLAG_READ | FLAG_WRITE)
#define OPEN_PORT		3		// ˿ڴȫ״̬
#define CLOSE_PORT		0		// ˿ڴڹر״̬
// ˿ڴʶFAIL_GREATESUCCEED_GREATESOCKET_BEING
#define		FAIL_GREATE			0		// socketʧ
#define		SUCCEED_GREATE		1		// socketɹ
#define		SOCKET_BEING		2		// socketѾڣ´


#define		AI_DATA_DISP			4
#define		DI_DATA_DISP			5
#define		PI_DATA_DISP			6

#define		WATCH_DATA_DISP			8


typedef u_char				BYTE;
typedef u_short				WORD;
typedef u_long 				DWORD;

#ifndef _WIN32
#define OS_UNIX
typedef unsigned long long ULONG_PTR, *PULONG_PTR;
typedef ULONG_PTR DWORD_PTR, *PDWORD_PTR;

#define LOWORD(l)           ((WORD)(((DWORD_PTR)(l)) & 0xffff))
#define HIWORD(l)           ((WORD)((((DWORD_PTR)(l)) >> 16) & 0xffff))
#define LOBYTE(w)           ((BYTE)(((DWORD_PTR)(w)) & 0xff))
#define HIBYTE(w)           ((BYTE)((((DWORD_PTR)(w)) >> 8) & 0xff))

#define _getpid getpid
#define _stricmp strcasecmp
#define Sleep(x) usleep(1000*x)
// #define GetPrivateProfileString QGetPrivateProfileString
#define max(a,b) (((a) > (b)) ? (a) : (b))
#define min(a,b) (((a) < (b)) ? (a) : (b))
#endif
#define		BYTE3(a)		(((a)&0xff)<<24)
#define		BYTE2(a)		(((a)&0xff)<<16)
#define		BYTE1(a)		(((a)&0xff)<<8)
#define		BYTE0(a)		((a)&0xff)

#define		ExchWord(a) 	(HIBYTE(a) | (LOBYTE(a)<<8))
#define		ExchDWord(a) 	(ExchWord(HIWORD(a)) | (ExchWord(LOWORD(a))<<16))
#define		BcdByteToInt( c ) (((c&0xf0) >> 4)*10 + (c&0x0f))
#define		IntToBcdByte( c ) ((c/10)*16 + (c%10))
#define		HexDigitToChar( c )	(((c) >= 10) ? ((c)-10+'A') : ((c)+'0'))
#define		HexCharToInt( c ) \
			(	((c) >= '0') && ((c) <= '9') ? (c) - '0' : \
				((c) >= 'a') && ((c) <= 'f') ? (c) - 'a' + 10 : \
				((c) >= 'A') && ((c) <= 'F') ? (c) - 'A' + 10 : 0 )

#define		INC_TOTAL_MSG( port ) (SioParam[port].MsgNum++)
#define		INC_Lost_SYNC_CNT( port ) (SioParam[port].LostSyncCnt++)
#define		INC_ERROR_MSG( port ) \
			do { \
				SioParam[port].ErrMsgNum++; \
				SioParam[port].MsgNum++; \
			} while ( 0 )


//궨
#define  	DEFAULT_UDP_COMM_PORT 		0xff00

//ڶдEEPROMPB6PB7ַ
#define		SUCC 							1
#define		FAIL 							0

#define		MAX_NET_BUF_SIZE				(80*1024)
#define		MAX_MSG_BUF_SIZE				81920

#define 	NET_MAC_LEN						6

#define 	DEFAULT_MAX_SERIAL_PORT_NUM		16
#define		DEFAULT_MAX_NET_PORT_NUM		8
#define 	DEFAULT_MAX_PORT_NUM			(DEFAULT_MAX_SERIAL_PORT_NUM+DEFAULT_MAX_NET_PORT_NUM)

#define		MAX_DEV_NUM						16

#define		MAX_PROV_PORT_NUM				16

#define		MAX_NET_NUM						3

#define		DEFAULT_BAUD					9600

//1豸óʼ
#define		SDS_GET_IP_ADDR					0x101
#define		SDS_N_GET_IP_ADDR				0x102
#define		SDS_SET_IP_ADDR					0x103

#define		SDS_GET_NET_MAC_CODE			0x109
#define		SDS_SET_NET_MAC_CODE			0x110

#define		SDS_SIO_RECV_DATA				0x141
#define		SDS_SIO_SEND_DATA				0x142

#define		SDS_SIO_SET_WATCH_PORT			0x161
#define		SDS_SIO_CLR_WATCH_PORT			0x162

//7Ϣ
#define		SDS_SIO_GET_PROTOCOL_NAME		0x201		// Э
#define		SDS_SIO_GET_PORT_CONFIG_INFO	0x203		// ˿ڹϢ
#define		SDS_SIO_GET_PROTOCOL_CONFIG_INFO	0x204		// ЭŶЭϢ

// йĿ
#define		SDS_SIO_GET_STAT_INFO			0x211		// ж˿ͳϢ
#define		SDS_SIO_CLR_STAT_INFO			0x212		// ˿ͳϢ
#define		SDS_SIO_GET_AI_DATA_INFO		0x213		// ˿ң
#define		SDS_SIO_GET_DI_DATA_INFO		0x214		// ˿ң
#define		SDS_SIO_GET_PI_DATA_INFO		0x215		// ˿ڵ

#define		SDS_SIO_GET_CONFIG_FILE			0x221		// portconfig.ini ļ
#define		SDS_SIO_SET_CONFIG_FILE			0x222		// дportconfig.ini ļ

#define		SDS_SIO_SET_SYSTEM_TIME			0x231		// ϵͳʱ

#define		SDS_SIO_RESET					0x255		// ˿ڵ

#define		MAX_MAP_REG_NUM					8

#define		NO_HANDSHAKE_MODE				0x00
#define		HARDWARE_MODE					0x01
#define		SOFTWARE_MODE					0x02

#define		RS232_COMM_MODE					0x00
#define		RS422_COMM_MODE					0x01
#define		RS485_COMM_MODE					0x02

#define		RS485_INPUT						0
#define		RS485_OUTPUT					1

#define		NO_COMM							0
#define		UDP_COMM						1
#define		TCP_S_COMM						2
#define		TCP_C_COMM						3

#define		RECV_PROTOCOL					0
#define		PROV_PROTOCOL					1
#define		PROTOCOL_SLAVE					PROV_PROTOCOL
#define		PROTOCOL_MASTER					RECV_PROTOCOL

#define		POLL_CMD_TYPE_NUM				3
#define		NORMAL_CMD_TYPE					0
#define		INSERAT_CMD_TYPE				1
#define		FAST_CMD_TYPE					2

//趨maskbit(&~maskbit)|bitȷλֵ
// λ
#define		BITMASK					0x03
#define		BIT5					0x00
#define		BIT6					0x01
#define		BIT7					0x02
#define		BIT8					0x03

// ֹͣλ
#define		STOPMASK				0x0c
#define		STOP1					0x04
#define		STOP2					0x08
#define		STOP15					0x0c

// Уλ
#define		PARITYMASK				0xf0
#define		PARITYNONE				0x00
#define		PARITYODD				0x10
#define		PARITYEVE				0x20
#define		PARITYMRK				0x30
#define		PARITYSPC				0x40

// 
#define		RTSMASK					0x01
#define		DTRMASK					0x02
#define		CTSMASK					0x04

#define		PNT_ENABLE			0		// ʹ
#define		PNT_STATE			1		// ״̬
#define		PNT_RAWVALUE		3       // ԭֵ(ң,)
#define		PNT_POLAR			5       // ң㼫
#define		PNT_STATUS			6       // ңŵ״̬
#define		PNT_CTRL_NO			7       // ңſص
#define		PNT_PROV_MSG		10      // תϢ
#define		PNT_SOE_TIME		20		// ң SOE ʱ
#define		PNT_ALL_MSG			21      // ȡϢ
#define		PNT_SOE_TIME_EX		22		// չϢңSOEʱ


#define		AI_PNT_TYPE			0
#define		DI_PNT_TYPE			1
#define		CN_PNT_TYPE			2
//#define		PI_PNT_TYPE			2
#define		PI_PNT_TYPE			3
#define		OD_PNT_TYPE			4

#define		AO_PNT_TYPE			20
#define		DO_PNT_TYPE			21

/*!
 	\brief ģ
 */
#define    PROTECT_AI_PNT_TYPE			128

/*!
 	\brief 
 */
#define    PROTECT_DI_PNT_TYPE          129

/*!
 	\brief ֵ
 */
#define    PROTECT_FIX_PNT_TYPE         130

/*!
 	\brief ¼
 */
#define    PROTECT_EVENT_PNT_TYPE       131


#define		POLL_CMD_TYPE_CMD	3
#define		NORMAL_POLL_CMD		0		// ͨ
#define		INSERT_POLL_CMD		1		// 
#define		FAST_POLL_CMD		2		// 

// TIMER_CNT, CREATE_CNT, LED_CNT1000
//#define		TIMER_CNT			20		// Pollʱʱ 20 ms
#define		TIMER_CNT			200		// Pollʱʱ 200 ms
#define		DATA_PRO_CNT		10		// ʱʱ 10 ms
#define		CREATE_CNT			100		// 100 ms
#define		LED_CNT				250		// 250 ms

#define		BLK_SIZE			256

#define		SYSTEM_TIME			300		// RTU ʱ, 300һ

#define		MAX_DISP_LINE		2048

#define     MAX_PROV_SOE        128

#define		STEP_YKYT_NOEXEC	0		//   
#define		STEP_YKYT_SELECT	1		// ңѡ
#define		STEP_YKYT_EXEC		2		// ңִ
#define		STEP_YKYT_CANCEL	3		// ңس
#define		STEP_YT_SELECT		4		// ңѡ
#define		STEP_YT_EXEC		5		// ңִ
#define		STEP_YT_CANCEL		6		// ң
#define		STEP_YKYT_DIRECT	7		// ֱ    
#define		STEP_YKYT_STOP		8		// ңͣ

// 
/*! 
	Ч
*/
#define		DT_NO				0
/*! 
	޷
*/
#define		DT_UINT             1
/*! 
	
*/
#define		DT_INT              2
/*! 
	
*/
#define		DT_FLOAT            3
/*! 
	ַ
*/
#define		DT_STRING           4
/*! 
	
*/
#define		DT_BINARY			5
/*! 
	
*/
#define		DT_CONTROL			6

// Ϣչչ2ֽڣеһָֽʾ, 
// ڶֽڸݲͬͬ
#define		CHECK_NO			1			// У飬ڶչֽЧ0
#define		CHECK_WHOLE			2			// У飬ڶչֽΪУ
#define		CHECK_GROUP			3			// У飬ڶչУ

#define DATATYPE_NO				-1
#define DATATYPE_AI				0
#define DATATYPE_DI				1
#define DATATYPE_OD				2
#define DATATYPE_STRING			3
#define DATATYPE_PI				4

// wen 2005.10.08 mallocڴ治ͷŵ
#define		MIN_MALLOC_SIZE				200				// mallocڴСߴ
#define		MAX_NO_WRITE_NUM			6000			// 󲻿дߴ
#define		MAX_BUFUNIT_NUM				100				// Ԫ

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// fendܵĺ궨
#define		MAX_HOST					2
#define		MAX_FEND					2
#define		MAX_ADDR					2
#define		MAX_NET_BUF					16384

#define		MMI_TYPE					0
#define		FEND_TYPE					1
#define		HOST_TYPE					2

#define		TCPIP_ADDR_LEN				32		// TCP/IP ͨѶַ󳤶
#define		MAX_MACHINE_NAME_LEN		48		// 󳤶

#define		MAX_RTU_MSG_SIZE			8192	// RTU Ϣ󳤶

#ifdef OS_LINUX
// linux¶Եֽڶ
typedef		int		SOCKET;
#define		INVALID_SOCKET				(SOCKET)(~0)
#endif

#define		__attribute__(x)
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

#define		MAX_POLL_CMD_BUF_LEN		256				// ѯָ󳤶

enum Param_Type
{
	PARAM_NO=0,
	PARAM_LINK,
	PARAM_DEV,
	PARAM_YC,
	PARAM_YX,
	PARAM_YM,
	PARAM_YK,
	PARAM_SYNCTIME,
	PARAM_ASDU10
};

#ifdef OS_WINDOWS
	#pragma pack (push,1)
#else// OS_UNIX
	#pragma pack(1)
#endif //OS_UNIX

//SDS ͷ
typedef struct
{
	BYTE			PortIdx;	        // Ϣ
	WORD  			MsgType;	        // Ϣ
	WORD 			MsgLen;             // Ϣ
} RTUMSGHEAD;

//SDSͽṹ
typedef struct
{
	BYTE			PortIdx;	        // Ϣ
	WORD  			MsgType;	        // Ϣ
	WORD 			MsgLen;		        // Ϣ
	u_char			MsgData[MAX_MSG_BUF_SIZE];
} RTUMSG;

//緢ʱ緳ṹ
typedef struct
{
	int			BufSize;
	int 		MsgCnt;
	int			Front;
	int			Rear;
	u_char		MsgData[MAX_MSG_BUF_SIZE];
} DATA_BUF;

struct WR_DATA
{
//	u_short				MsgType		;
	u_short				MsgLen;
	u_char				*MsgData;
	int					PLen;
	struct WR_DATA		*Next;
};

typedef struct
{
	WORD	PortNo;
	WORD	PntNo;	
	u_char	Enable;
	u_char	ChangeFlag;
	float	fFactor;

	// ģרò
	WORD	wType;		// ת
} PROV_AI_PNT;

typedef struct
{
	WORD	PortNo;
	WORD	PntNo;
	u_char	Enable;
	u_char	ChangeFlag;

	u_char	CtrlEnable;
	short	ControlNo;

	// ģרò
	WORD	wType;		// ת
} PROV_DI_PNT;

typedef PROV_AI_PNT	PROV_PI_PNT;

typedef struct
{
	WORD	PortNo;
	WORD	PntNo;
	u_char	Enable;
} PROV_PNT;

typedef struct
{
    BYTE		Enable;
	BYTE		State;			// ң״̬

	//WORD	   	RawValue;		// ңԭֵ
	DWORD	   	RawValue;		// ңԭֵ
	BYTE		Polar;			// 
    PROV_PNT	Prov[MAX_PROV_PORT_NUM];	// ת־
} AI_DEF;

typedef struct
{
    BYTE		Enable;
	BYTE		State;	// ң״̬

	BYTE  		Status;	// ң״̬
	u_char	    CtrlEnable;
	WORD 	    ControlNo;
	
	DAY_TIME	SoeTime;

    PROV_PNT	Prov[MAX_PROV_PORT_NUM];	// ת־
} DI_DEF;

typedef struct
{
    BYTE		Enable;
	BYTE		State;	// ״̬

    u_long		RawValue;	// ԭֵ

    PROV_PNT	Prov[MAX_PROV_PORT_NUM];	// ת־
} PI_DEF;

typedef struct
{
	int         iPntNo;         // SOE
	BYTE        bStatus;        // ״ֵ̬	
	
	// wen 2005.05.18 չֽڴ(103Ч)
	BYTE		u8Type;			// 103бΪasdu
	BYTE		u8ProvFun;		// 103תеFUN
	BYTE		u8ProvInf;		// 103תеINF
	WORD		wRelativeTime;	// ʱ
	WORD		wFaultNo;		// 

	DAY_TIME    SoeTime;        // SOEʱ

	// wen 2005.10.25 ַ¼еĹϲ
	char		szMsgEx[64];	// ֽô64ֽ

} SOE_DEF;

typedef struct
{
	int         iSoeNum;        // soe
	int         iFront;         // ָ
	int         iRear;          // βָ
	SOE_DEF     *ptrProvSoe;    // ˿soeݻ(MAX_PROV_SOE)
} PROV_SOE_DEF;

#define			YKYT_CMD_FROM_NO		0	// ûԴ
#define			YKYT_CMD_FROM_SCADA		1	// Դscadaϵͳ
#define			YKYT_CMD_FROM_PROVPORT	2	// Դת˿
// wen 2003.08.22 ңңת
typedef	struct
{
	int			m_iProvPortIdx;		// תվ˿ں
	int			m_iProvPntIdx;		// תվңŵ
	int			m_iProvYkYtPointIdx;// תվңң
	int			m_iYkYtPointIdx;	// ʵʳվңң
	
    int			m_iYkYtStep;		// ңңת(޲(=0)/ѡ(=1)/ִ(=2))	
	// ýṹԱ͵(תң)
	int			m_iYkYtOperate;		// ңңط֡غϡʧܣ
	int			m_iYkYtMode;		// ңңģʽ(104Ч)

	DAY_TIME	m_sDayTime;			// ң·ʱ
	int			m_iTimeOut;			// תңسʱʱ
	int			m_iCmdFrom;			// ָԴ(=0 Դ; =1 Դscada; =2 Դת˿)
} PROV_YKYT_DEF;

#define			YKYT_SEND_UP	1	//
#define			YKYT_SEND_DOWN	2	//

typedef struct
{
	int			m_iYkYtStep;		// ңңִв
	int			m_iYkYtPnt;			// ңң
	int			m_iYkYtOperate;		// ңң״̬ط֡غϡʧܣ
	int			m_iYkYtUpDown;		// (1=up, 0=down)
} YKYT_PARAM;

typedef struct
{
	//******************** ж˿Ϣ ************************
	DWORD		Baud;				// (cdtʱ)

	//**************** շ״̬*******************
	int         m_iRevStatus;		// ݻ״̬
	int         m_iNeedRevLength;   // Ҫյݳ
	
	//******************** Poll Cmd ****************************
	u_long		Retry;				// 
    u_long		RetryCnt;			// 
	u_long		RetryTime;			// ʱ
    u_long		RetryTimeCnt;		// ʱ
    u_long		WaitTime;			// ʱ
	u_long		WaitTimeCnt;		// ʱ

	u_char		ForceWaitFlag;		// ǿƵȴ־
	u_short		ForceWaitCnt;		// ǿƵȴ

	u_char		ReSendCmdFlag;		// ط־
	u_char		SendCmdFlag;		// ͱ־
    u_char		RevCmdFlag;			// ձ־

	u_char		LastGetCmdBuf;		// ǰʹû
	DATA_BUF	PollCmd[POLL_CMD_TYPE_NUM];
	
	//******************* ˿ݿ ***************************
	u_char		PortType;			// MAIN_PORT or SLAVE_PORT
	u_char      CheckTime;			// ʱУ(=0, ʱ; =1, ϶ʱ(); =2, ¶ʱ())

	WORD		AiNum;				// ˿ң
	WORD		DiNum;				// ˿ң
	WORD		PiNum;				// ˿ڵ
	
	void 		*AiPtr;				// ңڴָ
	void		*DiPtr;				// ңڴָ
	void		*PiPtr;				// ڴָ

	// wen 2004.11.16 תʱ
	u_char      DiChange;			// ңǷ仯
	u_char      AiChange;			// ңǷ仯
	// wen 2004.11.16 soeݵת洢
	PROV_SOE_DEF ProvSoeBuf;		// תsoeݻ
	PROV_YKYT_DEF ProvYkYtMsg;		// תңϢ
} SIO_PARAM_BAOHU_DEF;

typedef struct
{
	//***************** ж˿Ϣ ************************
	DWORD		Baud;				// 
	u_char		CommMode;			// λУֹͣλ
	u_char		WorkMode;			// ʽRS323422485

	int			Rs485WaitCnt;		// 485 лȴ

	u_char		ChipCheckOk;		// оƬ־
	u_char		ChSelect;			// оƬͺ
	u_char		FreqSelect;			// оƬƵ
	u_char		WrRegMap[MAX_MAP_REG_NUM];	// оƬĴӳ

	u_char		HandshakeMode;		// ͨѶַʽ
	u_char		XonChar1;			// ONַ1
	u_char		XonChar2;			// ONַ2
	u_char		XoffChar1;			// OFFַ1
	u_char		XoffChar2;			// OFFַ2
	//**********************************************************
} SIO_PARAM_SERIAL_DEF;

//вж
typedef struct
{
	//******************** ˿ڻϢ ************************
	u_char		ProtocolIdx;	// Լ 0
	u_char		ByPassFlag;		// ·־
	u_char		OpenFlag;		// 򿪱־(ñʶãڹڴ)
	u_char		Status;			// ˿״̬ж϶˿ǷͨѶ
	// ڶ˿1Ӻȫ, δȫˢµµұ
	int			iDelaySendAllData;// ȫӳٴ
	int			iForceSendFlag;	// ǿ·־
	
	//******************** ˿Ϣ ************************
	u_char		NetType;		// UDP_COMMTCP_S_COMMTCO_C_COMM
	DWORD		NetPort;		// ͨѶ˿
	u_long		NetCommIpAddr;	// ͨѶַ
	int			LiSock;			// socket
	int 		CommSock;		// ͨѶsocket
	//**********************************************************

	//******************** շ***********************
	DATA_BUF	RecvBuf;		// ݻ
	struct WR_DATA	*WriteData;	// ݻ

	//******************** ͳϢ ****************************
    u_long		MsgNum;			// ˿Ϣ
    u_long		LostSyncCnt;	// ˿ʧ
    u_long		ErrMsgNum;		// ˿ڴϢ
    u_long  	RecvCharNum;	// ˿ʱͳ
    u_long		SendCharNum;	// ˿ʱͳ
	u_long		LineCommCnt;	// ˿Ƿ߼

	//****************** ж˿Ϣ **************************
	SIO_PARAM_SERIAL_DEF *m_psSerial;
	//**********************************************************

	//******************* Ϣ *****************************
	SIO_PARAM_BAOHU_DEF *m_psBaoHu;
	//**********************************************************

	//******************** ûչṹ ************************
	void		*ExtInfo;
	//**********************************************************
} SIO_PARAM_DEF;

typedef struct
{
	u_long	AllIpAddr[MAX_NET_NUM];
	u_long	NetMaskIpAddr[MAX_NET_NUM];
	u_long	BroadCastIpAddr[MAX_NET_NUM];
	u_long	MainIpAddr[MAX_NET_NUM];
} HOST_IP_ADDR;

typedef struct
{
	WORD		PortNumber;
	SOCKET		Socket;

	struct sockaddr_in	Addr;

	u_char		WaitFalg;
} UDP_SET_DEF;

typedef struct
{
	int 		LineCnt;
	int			Front;
	int			Rear;
	char		Line[MAX_DISP_LINE][128];
} DISP_LINE_BUF;

typedef struct
{
	u_long		IpAddr[MAX_NET_NUM];
	u_char		NetNum;
	u_long		CurCommIp;
	u_char		IpAddrChangeFlag;
	u_char		NetCardMacCode[MAX_NET_NUM][NET_MAC_LEN];
	u_char		ReadMacCodeFlag;

	u_char		PortNum;
	u_char		SerialPortNum;
	u_char		NetPortNum;

	DISP_LINE_BUF	WatchDispLine;
} DEV_DEF;

// wen 2005.05.27 (ģֵĴ洢ṹ)
/*!
	\struct GROUPDATADEF
	\brief ͨ÷ݶ

	\par ٲο 
		common.h
 */
typedef struct
{
	/*!
        \var GROUPDATADEF::m_szName
        \brief Ϣ
        
        \note
            ȡֵΧ[ЧASCIIַ󳤶Ϊ64]\n
	*/
	char	m_szName[66];
	
	/*!
        \var GROUPDATADEF::m_u32DataID
        \brief 
        
        \note
            ȡֵΧ[DATAID_NO(0)---DATAID_SINGLE(10)]\n
			          ΪDATAID_NOݷظ
     */
	u_32	m_u32DataID;

	/*!
        \var GROUPDATADEF::m_fValue
        \brief Ϣֵ
        
        \note
            ȡֵΧȡֵΧ\n
     */
	float	m_fValue;

	/*!
        \var GROUPDATADEF::m_fMaxValue
        \brief Ϣֵ
        
        \note
            ȡֵΧȡֵΧ\n
     */
	float	m_fMaxValue;
	
	/*!
        \var GROUPDATADEF::m_fMinValue
        \brief ϢСֵ
        
        \note
            ȡֵΧȡֵΧ\n
     */
	float	m_fMinValue;

	/*!
        \var GROUPDATADEF::m_fStepValue
        \brief Ϣ㲽ֵ
        
        \note
            ȡֵΧȡֵΧ\n
     */
	float	m_fStepValue;

	/*!
        \var GROUPDATADEF::m_szUnit
        \brief Ϣ
        
        \note
            ȡֵΧ[ЧASCIIַ󳤶Ϊ16]\n
	*/
	char	m_szUnit[18];
	/*!
        \var GROUPDATADEF::iFixDataType
        \brief Ϣ͵protectʾ
        
        \note
            ȡֵΧ[0-255]((AI=1, DI=2))\n
	*/
	u_char	iFixDataType;

}GROUPDATADEF;

/*!
	\struct GROUPEVENTDEF
	\brief ¼

	\par ٲο 
		common.h
 */
typedef struct{	
	/*!
        \var GROUPEVENTDEF::m_iNewEventNo
        \brief ¼
        
        \note
            ȡֵΧ[0--(BUF_EVENT_NUM-1)=15]\n
     */
	i_32		m_iNewEventNo;
	/*!
        \var GROUPEVENTDEF::m_iNewEvents
        \brief ¼
        
        \note
            ȡֵΧ[0--16]\n
     */
	i_32		m_iNewEvents;
	/*!
        \var GROUPEVENTDEF::m_iAllEvents
        \brief ¼
        
        \note
            ȡֵΧ[0--16]\n
     */	
	i_32		m_iAllEvents;
	/*!
        \var GROUPEVENTDEF::m_sTm[]
        \brief ¼ʱ
     */
	//SYSTEMTIME	m_sTm[BUF_EVENT_NUM];
	/*!
        \var GROUPEVENTDEF::m_u8INF[]
        \brief ¼Ϣ
     */
//	BYTE		m_u8INF[BUF_EVENT_NUM];
}GROUPEVENTDEF;

/*!
	\struct GROUPDEF
	\brief ͨ÷鶨
	\note
		ģֵͨô洢ṹ

	\par ٲο 
		common.h
 */
typedef struct{
	/*!
        \var GROUPDEF::m_iGroupNo
        \brief ͨ÷
        
        \note
            ȡֵΧ[0--255]\n
     */
	i_32	m_iGroupNo;

	/*!
        \var GROUPDEF::m_iStartItemNo
        \brief ͨ÷ʼĿ
        
        \note
            ȡֵΧ[0--255]\n
     */
	i_32	m_iStartItemNo;
	
	/*!
        \var GROUPDEF::m_iDataType
        \brief ݶӦ
        
        \note
            ȡֵΧAI_PNT_TYPE(ģ)\n
					  DI_PNT_TYPE()\n
					  PI_PNT_TYPE()\n
					  PROTECT_AI_PNT_TYPE(ģ)\n
					  PROTECT_DI_PNT_TYPE()\n
					  PROTECT_FIX_PNT_TYPE( ֵ)\n
					  PROTECT_EVENT_PNT_TYPE( )\n
     */
	i_32	m_iDataType;
	
	/*!
        \var GROUPDEF::m_iStationNo
        \brief дݿеĳվ
        
        \note
            ȡֵΧ[0--MAX_PORT_NUM0ΪЧ(ȱʡֵ)]\n
     */
	i_32	m_iStationNo;
	
	/*!
        \var GROUPDEF::m_iStartPntNo
        \brief дݿеʼ
        
        \note
            ȡֵΧ[0--(͵-1)]\n
     */
	i_32	m_iStartPntNo;

	/*!
        \var GROUPDEF::m_u8NGD
        \brief ݵNGD
        
        \note
            ȡֵΧ[0--(͵-1)]\n
     */
	BYTE	m_u8NGD;

	/*!
        \var GROUPDEF::m_pu8DataType
        \brief ֵָ
        
        \note
            ȡֵΧ\n
     */
	BYTE	*m_pu8DataType;

	/*!
        \var GROUPDEF::m_pu8DataLen
        \brief ֵݳָ
        
        \note
            ȡֵΧ\n
     */
	BYTE	*m_pu8DataLen;

	/*!
        \var GROUPDEF::m_pu8GIN
        \brief ֵĿ
        
        \note
            ȡֵΧ\n
     */
	BYTE	*m_pu8GIN;

	/*!
        \var GROUPDEF::m_u32CurPntNo
        \brief ǰݵ
        
        \note
            ȡֵΧ[1--255]\n
		\note
		    ڴ֡ͨ÷ʱȷ֡ʼ
     */
	u_32	m_u32CurPntNo;

	/*!
        \var GROUPDEF::m_iPntNum
        \brief 
        
        \note
            ȡֵΧ\n
		\note
		    ңصͱֵ
     */
	i_32	m_iPntNum;

	/*!
        \var GROUPDEF::m_bInit
        \brief ֵݳ
        
        \note
            ȡֵΧ\n
     */
	BOOL	m_bInit;

	/*!
        \var GROUPDEF::m_psDataInfo
        \brief Ϣָ
        
        \note
            ȡֵΧ\n
     */
	GROUPDATADEF *m_psDataInfo;

	/*!
        \var GROUPDEF::m_psEventInfo
        \brief ¼Ϣָ
        
        \note
            ȡֵΧ¼¼飬ָΪNULL\n
     */
	GROUPEVENTDEF *m_psEventInfo;
}GROUPDEF;

/*!
	\struct DBINFO
	\brief ֵϢ

	\par ٲο 
		common.h
 */
typedef struct{
	/*!
        \var DBINFO::m_u8Asdu
        \brief ֵ
		\note
            ȡֵΧ[0--255)]\n
     */
	u_char  m_u8Asdu;	// 
	
	// wen 2006.05.20 ޸Ϊ16λ
	/*!
        \var DBINFO::m_u8Fun
        \brief ֵĹ
		\note
            ȡֵΧ[0--255)]\n
     */	
	WORD  m_u8Fun;	// 
	/*!
        \var DBINFO::m_u8Inf
        \brief ֵϢ
		\note
            ȡֵΧ[0--255]\n
     */
	WORD  m_u8Inf;	// Ϣ	

	// ²ת
	/*!
        \var DBINFO::m_u8ProvFun
        \brief ֵĹ
		\note
            ȡֵΧ[0--255)]\n
     */
	BYTE	m_u8ProvFun;
	/*!
        \var DBINFO::m_u8ProvInf
        \brief ֵϢ
		\note
            ȡֵΧ[0--255]\n
     */
	BYTE	m_u8ProvInf;
	/*!
        \var DBINFO::m_u8LoopData
        \brief Ƿٻ
		\note
            ȡֵΧ[0--1]\n
     */
	BYTE	m_u8LoopData;
}DBINFO, *pDBINFO;

/*!
	\struct DBORIENTATION
	\brief ֵݿⶨλṹ

	\par ٲο 
		common.h
 */
typedef struct
{
	/*!
        \var DBORIENTATION::m_iStnNo
        \brief ֵݿдվ
		\note
            ȡֵΧ[1--վ)]\n
     */
	i_32    m_iStnNo;	// дݿվ

	/*!
        \var DBORIENTATION::m_iStartPntNo
        \brief ֵݿʼ
		\note
		    ΪԼṩĲֵ
        \note
            ȡֵΧ[0--(ң-1)]\n
     */
	i_32    m_iStartPntNo;	// дݿʼ
	
	/*!
        \var DBORIENTATION::m_iPntNum
        \brief ֵ
		\note
            ȡֵΧ[0--255]\n
     */
	i_32   m_iPntNum;			// 
	
	/*!
        \var DBORIENTATION::m_psDataInfo
        \brief ֵϢָ		    
     */
	pDBINFO m_psDataInfo;	
}DBORIENTATION;

typedef struct tagDEVADDRPARAM
{
	/*!
       \var DEVADDRPARAM::m_uchLinkAddr
       \brief ·ַ
     */
	BYTE	m_uchLinkAddr;
	/*!
       \var DEVADDRPARAM::m_uchCommAddr
       \brief ַ
     */
	BYTE	m_uchCommAddr;
	/*!
       \var DEVADDRPARAM::m_iLinkIdx
       \brief ·
     */
	int		m_iLinkIdx;
	/*!
       \var DEVADDRPARAM::m_iDevIdx
       \brief װ
     */
	int		m_iDevIdx;
}DEVADDRPARAM, *pDEVADDRPARAM;

typedef struct tagCMDPARAM
{
	/*!
       \var CMDPARAM::m_uchFun
       \brief ָܺ
     */
	BYTE	m_uchFun;
	/*!
       \var CMDPARAM::m_uchInf
       \brief ָϢ
     */
	BYTE	m_uchInf;
	/*!
       \var CMDPARAM::m_uchRII
       \brief ֵ
     */
	BYTE	m_uchRII;
	/*!
       \var CMDPARAM::m_sDevAddr
       \brief ַָϢ
     */
	DEVADDRPARAM m_sDevAddr;
}CMDPARAM, *pCMDPARAM;

typedef	struct tagBAOHUPROVPARAM
{
	/*!
		\var BAOHUPROVPARAM::m_sProvStartTime
		\brief תָ·ʱ
	*/
	DAY_TIME	m_sBaoHuCmdStartTime;
	/*!
		\var BAOHUPROVPARAM::m_iBaoHuCommid
		\brief תָ˿
		\note  <0, ûеת
	*/
	int			m_iBaoHuCommid;
	/*!
		\var BAOHUPROVPARAM::m_iBaoHuMsgType
		\brief ָ
		\note  <0, ûеת
	*/
	int			m_iBaoHuMsgType;
	/*!
		\var BAOHUPROVPARAM::m_sProvRealAddrParam
		\brief תָʱʵװõĲ
	*/
	DEVADDRPARAM	m_sRealAddrParam;
}BAOHUPROVPARAM, *pBAOHUPROVPARAM;

#define		PROV_SOE_MAX	10
/*!
	\struct DEVPROVSOE
	\brief תSOEݽṹ

	\par ٲο 
		common.h
 */
typedef struct
{
	/*!
	   \var DEVPROVSOE::m_sSoeData
       \brief תSOEݲ
       
	   \note
	       ת¼       
	*/
	SOE_DEF		m_sSoeData[PROV_SOE_MAX];

	/*!
	   \var DEVPROVSOE::m_shSoeNum
       \brief תSOEĿ
       
	   \note
	       ת¼       
	*/
	short		m_shSoeNum;

	/*!
	   \var DEVPROVSOE::m_shFront
       \brief תSOEͷ
       
	   \note
	       ת¼       
	*/
	short		m_shFront;

	/*!
	   \var DEVPROVSOE::m_shRear
       \brief תSOEβ
       
	   \note
	       ת¼       
	*/
	short		m_shRear;
}DEVPROVSOE;

// йԼͨúӿָ
typedef const struct tagFUNCTION_CALL
{
	char	*ProtocolName;								// Լ
	char	*Account;									// Լ˵
	char	**ProtocolInfo;								// ԼϢָ
	void	(*ReadConfig)( int );						// ʼ
	void	(*RecvData)( int, u_char *, int );			// Լݴ
	void	(*Timer)( int );							// ʱ
	void	(*YkYtProcess)( int, u_char *, int );		// ңң
	void	(*SendSystemTime)( int );					// ϵͳʱ
	void	(*ProtocolExit)( int );						// Լ˳ʱ
	// ºָԱԼЧ
	void	(*BaoHuCmdProcess)(int, RTUMSG *, BOOL);	// ݴ
	int     (*GetBaohuDataBase)(int, int, GROUPDEF **);	// ȡݿ
}FUNCTION_CALL;

#ifdef OS_WINDOWS
	#pragma pack (pop)
#else// OS_UNIX
	#pragma pack (0)
#endif //OS_UNIX
#endif