/************************************************************************
 *
 *	Copyright (C) 2003-2004
 *	Shenzhen SCADA Control Technology Co., Ltd.
 *	All rights reserved.
 *	
 *	ڵڴй©Ķڴ亯ʵ
 *
 *	:	2005/04/12
 *
 ***********************************************************************/
/*#ifdef OS_LINUX
#include <sys/types.h>
#include <sys/time.h>
#endif*/

#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
#include <string.h>
#include <errno.h>

#include "time.h"
#include "list_entry.h"
#include "os_heap.h"

#if defined(_WIN32)
  #include <winsock2.h>
  #include <direct.h>
  #include <process.h>
#endif

#ifdef _fclose
#undef _fclose
#endif
#define _fclose(_fp) do {if (_fp) {while (EOF == fclose((_fp)) && EINTR == errno);}} while(0)

/*!
 *  ڴ
 */
typedef enum {
    eMalloc = 0, /* ʹmallocڴ */
    eCalloc = 1  /* ʹcallocڴ */
} heap_type_t;

/*!
 *  ڴ鸽ͷ
 *
 *  \note
 *      뱣֤ṹĳߴ类16
 */
typedef struct tag_heap_head_t {

    /* ڴ鸽ͷڵռλ */
    list_entry_t    anchor;

    /*! ڴ䷢ʱ */
    struct timeval     tv;

    /*! ڴ */
    heap_type_t     type;

    /*! ڴ䷢ԴļNULLʾԴļ */
    char * fl;

    /*! ڴ䷢Դ */
    int  line;

    /*! ڴĳߴ(ֽ) */
    size_t size;

} heap_list_t;


/* ߽ */
#define os_heap_alignment   16
#define os_heap_pad ((sizeof(heap_list_t) % os_heap_alignment) ? (os_heap_alignment - (sizeof(heap_list_t) % os_heap_alignment)) : 0)

/* ݵַos_heapʼַ */
#define os_heap_start_addr(_data) ((void *)(((unsigned char *)(_data)) - sizeof(heap_list_t) - os_heap_pad))

/* os_heapʼַݵַ */
#define os_heap_data_addr(_start) ((void *)(((unsigned char *)(_start)) + sizeof(heap_list_t) + os_heap_pad))

/* ݿĳߴos_heapĳߴ */
#define os_heap_mb_size(_size) (sizeof(heap_list_t) + os_heap_pad + (_size))

/*
 *  ڴģ飺
 *
 *  1. ʼ
 *  2. һ˽̣߳רⲿźţӡ档
 *  3. ڴͷβָ롣
 *  4. ʱ
 */

/* ڴʩǷѾʼ */
static int          g_heap_initialized = 0;

/* ڴ˫ͷ */
static list_entry_t g_heap_head;

/*
 *  ʹheap_malloc/heap_callocڴ
 *  ڻʹõڴ
 */
static size_t       g_heap_item_counter = 0;

/* 
 *  ʹheap_malloc/heap_callocڴ
 *  ڻʹõ(ֽ) 
 */
static size_t       g_heap_byte_counter = 0;


/* ʼڴʩ */
static void heap_intialize();

/*!
 *  \brief ڴ
 *
 *  \param size ϣڴĳߴ
 *  \param file ָڴԴļƣnullַβ
 *              NULL ʾԴļ(anony)
 *  \param line ڴԴк
 *
 *  \retutrn 
 *      ڴɹ£ָڴָ롣ڴ
 *      ʧܣNULL
 *
 *  \note
 *      ڴ治ʹʱheap_freeǷڴ档
 *
 *      μ ANSI C  malloc
 */
void * heap_malloc (
        size_t size, 
        const char * file, 
        int line )
{
 // #ifdef DISABLE_OS_HEAP
    return malloc(size);
  /*#else /* #ifdef DISABLE_OS_HEAP */
/*
    struct timeval tv;
    char * fl = NULL;
    void * mb = NULL;
    heap_list_t * hl = NULL;

    if (0 == size) 
        return NULL;

    if (file) {
        fl = (char *)malloc(strlen(file) + 4);
        if (fl) strcpy (fl, file);
    }

    gettimeofday(&tv, NULL);

    mb = malloc(os_heap_mb_size(size));
    if (NULL == mb) {
        if (fl) free (fl);
        return mb;
    } else {
        memset (mb, 0, os_heap_mb_size(size));
    }

    hl = (heap_list_t *)mb;

    hl->type = eMalloc;
    hl->tv = tv;
    hl->fl = fl;
    hl->line = line;
    hl->size = size;

    if (!g_heap_initialized) {
        heap_intialize();
        g_heap_initialized = 1;
    }

    insert_tail_list (&g_heap_head, &(hl->anchor));
    g_heap_item_counter++;
    g_heap_byte_counter += hl->size;
    
    return os_heap_data_addr(hl);
  #endif *//* #ifdef DISABLE_OS_HEAP */
}

/*!
 *  \brief ڴ, ڴ鱻ʼ0.
 *
 *  \param num      ڴ
 *  \param elm_size ÿһڴĳߴ(ֽ)
 *  \param file ָڴԴļƣnullַβ
 *              NULL ʾԴļ(anony)
 *  \param line ڴԴк
 *
 *  \retutrn 
 *      ڴɹ£ָڴָ롣ڴ
 *      ʧܣNULL
 *
 *  \note
 *      ڴ治ʹʱheap_freeͷŷڴ档
 *      
 *      μ ANSI C  calloc calloc ֮ͬڲ
 *      calloc֤صĶڴʵַelm_size߽
 *      ϡ
 */
void * heap_calloc (
        size_t num, 
        size_t elm_size, 
        const char * file, 
        int line )
{
  //#ifdef DISABLE_OS_HEAP
    return calloc(num, elm_size);
  //#else /* #ifdef DISABLE_OS_HEAP */

  /*  struct timeval tv;
    char * fl = NULL;
    void * mb = NULL;
    heap_list_t * hl = NULL;

    if (0 == num * elm_size)
        return NULL;

    if (file) {
        fl = (char *)malloc(strlen(file) + 4);
        if (fl) strcpy (fl, file);
    }

    gettimeofday(&tv, NULL);

    mb = malloc(os_heap_mb_size(elm_size * num));
    if (NULL == mb) {
        if (fl) free (fl);
        return mb;
    } else {
        memset (mb, 0, os_heap_mb_size(elm_size * num));
    }

    hl = (heap_list_t *)mb;

    hl->type = eCalloc;
    hl->tv = tv;
    hl->fl = fl;
    hl->line = line;
    hl->size = elm_size * num;

    if (!g_heap_initialized) {
        heap_intialize();
        g_heap_initialized = 1;
    }

    insert_tail_list (&g_heap_head, &(hl->anchor));
    g_heap_item_counter++;
    g_heap_byte_counter += hl->size;
    
    return os_heap_data_addr(hl);
  #endif *//* #ifdef DISABLE_OS_HEAP */
}

/*!
 *  \brief  ͷŶڴ
 *
 *  \param  memblock  ָǰheap_alloc/heap_callocڴ档
 *
 *  \return 
 *      ޡ
 */
void heap_free (void * mb)
{
  #ifdef DISABLE_OS_HEAP
    free (mb);
  #else /* #ifdef DISABLE_OS_HEAP */
    size_t sz = 0;
    heap_list_t * hl = NULL;

    if (NULL == mb)
        return;

    if (!g_heap_initialized) {
        heap_intialize();
        g_heap_initialized = 1;
        return;
    }

    hl = (heap_list_t *)os_heap_start_addr(mb);

    #if defined(WIN32) && (defined(DEBUG) || defined(_DEBUG))
    if (IsBadReadPtr((void *)hl, sizeof(heap_list_t))) {
        return;
    }
    
    if (IsBadReadPtr((void *)hl, os_heap_mb_size(hl->size))) {
        return;
    }
    #endif

    remove_entry_list (&(hl->anchor));
    sz = hl->size;
    if (hl->fl) 
        free ((void *)(hl->fl));
    free ((void *)hl);
    
    g_heap_item_counter--;
    g_heap_byte_counter -= sz;
    
  #endif /* #ifdef DISABLE_OS_HEAP */
}

/*!
 *  \brief  ڴ
 *
 *  ñڴ׷ӵķʽָļС
 *
 *  \param fname ڴ䱨潫ļСfnameNULL
 *              򱨸潫׼ϡ
 *
 *  \retval -1 ʧܡ
 *  \retval 0  óɹ
 *
 *  \note
 *      ĸʽ
 *      ʱ: 
 *      ڴʹ: 
 *      ......
 *      ڴбi: 
 *          ʱ: tv
 *          : malloc/calloc, 
 *          Դλ: fl(line)
 *          ߴ: size
 *      ......
 */
int heap_report(const char * fname)
{
 /* #ifndef DISABLE_OS_HEAP
    int i = 0;
    FILE * fp = NULL;

    heap_list_t * hl = NULL;

    list_entry_t * item = NULL;
	list_entry_t * first = NULL;
	list_entry_t * next = NULL;

    char szdt[32];

    if (fname) {
        fp = fopen (fname, "a+t");
        if (NULL == fp)
            return -1;
    } else
        fp = stdout;

    if (!g_heap_initialized) {
        heap_intialize();
        g_heap_initialized = 1;
        if (fname) _fclose(fp);
        return 0;
    }

    fprintf (fp, "\n"
                 "heap allocation summary...\n"
                 "time: %s\n"
                 "heap_item_counter: %u\n"
                 "heap_byte_counter: %u(bytes)\n",
                 cur_tm_string (szdt), 
                 g_heap_item_counter,
                 g_heap_byte_counter);
    
    first = &g_heap_head;
	for ( next = first->flink; next != first; next = next->flink )
	{
		item = next;
		hl = CONTAINING_RECORD ( item, heap_list_t, anchor );

        fprintf (fp, "  heap block %d:"
                     " times: %s"
                     " type: %s"
                     " size: %08u (bytes)"
                     " source: %s [%d]\n",
                     i++, timeval_string(&(hl->tv), szdt),
                     (eMalloc == hl->type ? "malloc" : "calloc"),
                     hl->size, (hl->fl ? hl->fl : "nony"), hl->line);
	}

    if (fname) _fclose(fp);
  #endif*/

    return 0;
}

static void heap_intialize()
{
    Initialize_list_head (&g_heap_head);
}
